'Cubic-Equation Evaluator
'(Dec. 30, 2000)
'By Achilles Mina

'This utility extracts the roots of a cubic equation if they're real
'numbers. This is one of the modules of Calculait 3.0, a full-featured
'scientific calculator with a world clock. It will soon be available
'for downloading from ZDNet, Nonags, RocketDownload, CNet and other freeware
'sites. Version 2.0 is currently downloadable at these sites.

'You can do as you please with this code.

$INCLUDE "RAPIDQ.INC"
DECLARE SUB CubicRoots

CREATE Arial9B AS QFONT
    Name = "Arial"
    Color = clBlack
    AddStyles(fsBold)
    Size = 9
END CREATE

CREATE ArialG AS QFONT
    Name = "Arial"
    Color = clBlack '&HEEFE   
    AddStyles(fsBold)
    Size = 12
END CREATE

CREATE TimeFont AS QFONT
    Name = "Univers"
    Color = clGreen
    Size = 12
    AddStyles(fsBold)
END CREATE

  CREATE CubicForm AS QFORM    
    Center
    Caption = "Cubic Equation"
    Width = 237
    Height = 205
    Color = &HABC111
    FormStyle = fsStayOnTop
    DelBorderIcons(biMaximize)
    BorderStyle = bsSingle
    CREATE CubicPanel AS QPanel
      Font = ArialG
      Left = 10
      Top = 5
      Width = 220
      Height = 15
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Caption = "x" + CHR$(0179) + " + ax + bx + c"
    END CREATE
    CREATE Ac AS QEDIT
      Left = 10
      Top = 30
      Width = 45
      Height = 21
      TabOrder = 1
    END CREATE
    CREATE CubicPanel1 AS QPanel
      Font = ArialG
      Alignment = taLeftJustify
      Left = 56
      Top = 31
      Width = 53
      Height = 21
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Caption = "x"
    END CREATE    
    CREATE Bc AS QEDIT
      Left = 95
      Top = 30
      Width = 45
      Height = 21
      TabOrder = 2
    END CREATE
    CREATE CubicPanel2 AS QPanel
      Font = ArialG
      Alignment = taLeftJustify
      Left = 141
      Top = 31
      Width = 47
      Height = 21
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Caption = "x"
    END CREATE
    CREATE Cc AS QEDIT
      Left = 174
      Top = 30
      Width = 45
      Height = 21
      TabOrder = 3
    END CREATE      
    CREATE CubicButt AS QBUTTON
      Font = Arial9B
      Caption = "Press to get roots"
      Left = 10
      Top = 60
      Width = 210
      TabOrder = 6
      OnClick = CubicRoots
    END CREATE
    CREATE CubicPanel3 AS QPANEL
      Left = 10
      Top = 85
      Width = 210
      Height = 30
      Color = Black
      Font = TimeFont
    END CREATE
    CREATE CubicPanel4 AS QPANEL
      Left = 10
      Top = 116
      Width = 210
      Height = 30
      Color = Black
      Font = TimeFont
    END CREATE
    CREATE CubicPanel5 AS QPANEL
      Left = 10
      Top = 147
      Width = 210
      Height = 30
      Color = Black
      Font = TimeFont
    END CREATE         
  END CREATE

SUB CubicRoots
  IF soundoff = 0 THEN PLAYWAV  "whooh.wav",1
  a = VAL(Ac.Text)
  b = VAL(Bc.Text)
  c = VAL(Cc.Text)
  Q = (a^2 - 3*b)/9
  R = (2*a^3 -9*a*b + 27*c)/54
  Qcubed = Q^3
  d = Qcubed - R^2
  IF d >= 0 THEN
    theta = ACOS(R/SQR(Qcubed))
    sqrtQ = SQR(Q)
    CubicPanel3.Caption = STR$(-2*sqrtQ*COS(theta/3) - a/3)
    CubicPanel4.Caption = STR$(-2*sqrtQ*COS((theta + 2*3.141592654)/3) - a/3)
    CubicPanel5.Caption = STR$(-2*sqrtQ*COS((theta + 4*3.141592654)/3) - a/3)
  ELSE
    'e = SQR(-d) + (ABS(R))^(1/3)
    'x1 = (e + Q/e) - a/3
    'IF R > 0 THEN x1 = -x1
    x1 = -1
    DO
      old = x1
      new = -(old^3 + a*old^2 + c)/b
      x1 = (old + new)/2
    LOOP UNTIL ABS(new - x1) < .000001
    CubicPanel3.Caption = STR$(x1)
    CubicPanel4.Caption = "The other 2 roots"
    CubicPanel5.Caption = "are complex numbers."
  END IF   
END SUB

CubicForm.ShowModal